<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995, 1996 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>section 7.6: Error Handling -- Stderr and Exit</title>
<link href="sx10e.html" rev=precedes>
<link href="sx10g.html" rel=precedes>
<link href="sx10.html" rev=subdocument>
</head>
<body>
<H2>section 7.6: Error Handling -- Stderr and Exit</H2>

page 163
<p><TT>stdout</TT> and <TT>stderr</TT> are both predefined output streams;
for our purposes,
the only difference between them
is that <TT>stderr</TT> is not likely to be redirected by the user,
so the error messages printed to <TT>stderr</TT>
will always appear on the screen,
where they can be seen.
</p><p>page 164
</p><p>The cryptic note about ``a pattern-matching program''
simply means that if you want to search
the source code of a program
for all the exit status values it can return,
``exit'' might be an easier string to search for
than ``return.''
(Every call to <TT>exit</TT> represents an exit from the program,
but not every <TT>return</TT> statement does.)
</p><p>The <TT>feof</TT> and <TT>ferror</TT> functions can be used
to check for error conditions more carefully.
In general, input routines (such as <TT>getchar</TT> and 
<TT>getline</TT>) return some special value to tell you that they 
couldn't read any more.
Often, this value is <TT>EOF</TT>, reinforcing the notion that 
the only possible reason they couldn't read any more was because 
end-of-file had been reached.
However, it's also possible

that there was a read error,
and
you can call <TT>feof</TT> or <TT>ferror</TT> to
determine whether this was the case.
On the output side,
though the output routines generally do return an error indication,
few programs bother to check the return values
from every call to functions
such as <TT>putchar</TT> and <TT>printf</TT>.
One way to check for output errors,
without having to check the return value of every
function, 
is to call <TT>ferror</TT> on the output stream
(which might be <TT>stdout</TT>)
at key points.
</p><hr>
<p>
Read sequentially:
<a href="sx10e.html" rev=precedes>prev</a>
<a href="sx10g.html" rel=precedes>next</a>
<a href="sx10.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995, 1996
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
